# Written by teen tech twitter's president, @nulljosh
# github.com/probablyjosh/ttt

# Require gems
require 'twitter'
require 'json'
require 'commander/import'
require_relative 'ttt/version'

program :name, 'teen tech twitter client'
program :version, Ttt::Version::STRING
program :description, 'The official Twitter CLI for Tech Teen Twitter'

file = ENV['HOME'] + '/.ttt_keys.json'
if File.file? file
  keys = JSON.parse(File.read(file))
  client = Twitter::REST::Client.new do |config|
    config.consumer_key        = keys['consumer_key']
    config.consumer_secret     = keys['consumer_secret']
    config.access_token        = keys['access_token']
    config.access_token_secret = keys['access_token_secret']
  end
end

command :init do |c|
  c.syntax = 'ttt init'
  c.description = 'Initializes ~/.ttt_keys.json'
  c.action do
    tempHash = {
      :consumer_key =>        ask("Consumer key: "),
      :consumer_secret =>     ask("Consumer secret: "),
      :access_token =>        ask("Access Token: "),
      :access_token_secret => ask("Access Token Secret: ")
      }

    file = ENV['HOME'] + '/.ttt_keys.json'
    File.open(file, 'w') { |f| f.write(JSON.pretty_generate(tempHash)) }
    puts "Keys written to #{file}"
  end
end

command :members do |c|
  c.syntax = 'ttt members'
  c.description = 'Lists TTT\'s current members'
  c.action do
    client.lists.each do |list|
      if list.name == "Teen Tech Twitter"
        client.list_members(list).each do |user|
          puts "#{user.name} - @#{user.screen_name}"
        end
      end
    end
  end
end

command :tweet do |c|
  c.syntax = 'ttt tweet'
  c.description = 'Tweets to a specified user in the list'
  c.option '--to STRING', String, 'The user you want to tweet to'
  c.option '--body STRING', String, 'The body of the tweet'
  c.action do |args, options|
    client.lists.each do |list|
      if list.name == "Teen Tech Twitter"
        members = []
        client.list_members(list).each { |user| members << user.screen_name }
        if members.include? options.to
          client.update('@' + options.to + ' ' + options.body)
          puts "Success: #{options.to} is a tech teen"
        else
          puts "Error: #{options.to} is not a tech teen"
        end
      end
    end
  end
end
